Index: /branches/GeneralizedQAP/UnitTests/GQAPNMoveEvaluatorTest.cs
===================================================================
--- /branches/GeneralizedQAP/UnitTests/GQAPNMoveEvaluatorTest.cs	(revision 15503)
+++ /branches/GeneralizedQAP/UnitTests/GQAPNMoveEvaluatorTest.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -35,9 +35,5 @@
   public class GQAPNMoveEvaluatorTest {
     private const int Equipments = 10, Locations = 5;
-    private static DoubleMatrix symmetricWeights, asymmetricWeights, nonZeroDiagonalWeights;
-    private static DoubleMatrix symmetricDistances, asymmetricDistances, nonZeroDiagonalDistances;
-    private static DoubleMatrix installationCosts;
-    private static DoubleArray demands, capacities;
-    private static double transportationCosts, overbookedCapacityPenalty;
+    private static GQAPInstance symmetricInstance, asymmetricInstance, nonZeroDiagonalInstance;
     private static IntegerVector assignment;
     private static MersenneTwister random;
@@ -58,10 +54,10 @@
     public static void MyClassInitialize(TestContext testContext) {
       random = new MersenneTwister();
-      symmetricDistances = new DoubleMatrix(Locations, Locations);
-      symmetricWeights = new DoubleMatrix(Equipments, Equipments);
-      asymmetricDistances = new DoubleMatrix(Locations, Locations);
-      asymmetricWeights = new DoubleMatrix(Equipments, Equipments);
-      nonZeroDiagonalDistances = new DoubleMatrix(Locations, Locations);
-      nonZeroDiagonalWeights = new DoubleMatrix(Equipments, Equipments);
+      var symmetricDistances = new DoubleMatrix(Locations, Locations);
+      var symmetricWeights = new DoubleMatrix(Equipments, Equipments);
+      var asymmetricDistances = new DoubleMatrix(Locations, Locations);
+      var asymmetricWeights = new DoubleMatrix(Equipments, Equipments);
+      var nonZeroDiagonalDistances = new DoubleMatrix(Locations, Locations);
+      var nonZeroDiagonalWeights = new DoubleMatrix(Equipments, Equipments);
       for (int i = 0; i < Equipments - 1; i++) {
         for (int j = i + 1; j < Equipments; j++) {
@@ -86,5 +82,5 @@
         nonZeroDiagonalDistances[i, i] = random.Next(Locations * 100);
       }
-      installationCosts = new DoubleMatrix(Equipments, Locations);
+      var installationCosts = new DoubleMatrix(Equipments, Locations);
       for (int i = 0; i < Equipments; i++) {
         for (int j = 0; j < Locations; j++) {
@@ -92,9 +88,9 @@
         }
       }
-      demands = new DoubleArray(Equipments);
+      var demands = new DoubleArray(Equipments);
       for (int i = 0; i < Equipments; i++) {
         demands[i] = random.Next(1, 10);
       }
-      capacities = new DoubleArray(Locations);
+      var capacities = new DoubleArray(Locations);
       for (int j = 0; j < Locations; j++) {
         capacities[j] = random.Next(1, 10) * ((double)Equipments / (double)Locations) * 1.5;
@@ -107,7 +103,35 @@
         nonZeroDiagonalWeights[index, index] = random.Next(1, Equipments * 100);
 
-      transportationCosts = random.NextDouble() * 10;
-      overbookedCapacityPenalty = 1000 * random.NextDouble() + 100;
+      var transportationCosts = random.NextDouble() * 10;
+      var overbookedCapacityPenalty = 1000 * random.NextDouble() + 100;
       assignment = new IntegerVector(Equipments, random, 0, Locations);
+
+      symmetricInstance = new GQAPInstance() {
+        Capacities = capacities,
+        Demands = demands,
+        InstallationCosts = installationCosts,
+        PenaltyLevel = overbookedCapacityPenalty,
+        TransportationCosts = transportationCosts,
+        Weights = symmetricWeights,
+        Distances = symmetricDistances
+      };
+      asymmetricInstance = new GQAPInstance() {
+        Capacities = capacities,
+        Demands = demands,
+        InstallationCosts = installationCosts,
+        PenaltyLevel = overbookedCapacityPenalty,
+        TransportationCosts = transportationCosts,
+        Weights = asymmetricWeights,
+        Distances = asymmetricDistances
+      };
+      nonZeroDiagonalInstance = new GQAPInstance() {
+        Capacities = capacities,
+        Demands = demands,
+        InstallationCosts = installationCosts,
+        PenaltyLevel = overbookedCapacityPenalty,
+        TransportationCosts = transportationCosts,
+        Weights = nonZeroDiagonalWeights,
+        Distances = nonZeroDiagonalDistances
+      };
     }
     #endregion
@@ -119,28 +143,40 @@
     [TestMethod()]
     public void EvaluateTest() {
-      var evaluator = new GQAPAdditivePenaltyEvaluator();
       for (int i = 0; i < 500; i++) {
-        NMove currentMove = StochasticNMoveSingleMoveGenerator.GenerateUpToN(random, assignment, 3, capacities);
+        NMove currentMove = StochasticNMoveSingleMoveGenerator.GenerateUpToN(random, assignment, 3, symmetricInstance.Capacities);
         IntegerVector prevAssignment = (IntegerVector)assignment.Clone();
         NMoveMaker.Apply(assignment, currentMove);
-        double before = evaluator.Evaluate(prevAssignment, symmetricWeights, symmetricDistances, installationCosts, demands, capacities, transportationCosts, 0);
-        double after = evaluator.Evaluate(assignment, symmetricWeights, symmetricDistances, installationCosts, demands, capacities, transportationCosts, 0);
-        double moveDiff = GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, symmetricWeights, symmetricDistances, installationCosts, demands, capacities, transportationCosts, 0, evaluator);
+        var beforeEval = symmetricInstance.Evaluate(prevAssignment);
+        double before = symmetricInstance.ToSingleObjective(beforeEval);
+        double after = Evaluate(symmetricInstance, assignment);
+        double moveDiff = symmetricInstance.ToSingleObjective(
+          GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, beforeEval, symmetricInstance)
+          ) - symmetricInstance.ToSingleObjective(beforeEval);
         Assert.IsTrue(Math.Abs(moveDiff - (after - before)) < 1e-07, "Failed on symmetric matrices: " + Environment.NewLine
           + "Quality changed from " + before + " to " + after + " (" + (after - before).ToString() + "), but move quality change was " + moveDiff + ".");
 
-        before = evaluator.Evaluate(prevAssignment, asymmetricWeights, asymmetricDistances, installationCosts, demands, capacities, transportationCosts, 0);
-        after = evaluator.Evaluate(assignment, asymmetricWeights, asymmetricDistances, installationCosts, demands, capacities, transportationCosts, 0);
-        moveDiff = GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, asymmetricWeights, asymmetricDistances, installationCosts, demands, capacities, transportationCosts, 0, evaluator);
+        beforeEval = asymmetricInstance.Evaluate(prevAssignment);
+        before = asymmetricInstance.ToSingleObjective(beforeEval);
+        after = Evaluate(asymmetricInstance, assignment);
+        moveDiff = asymmetricInstance.ToSingleObjective(
+          GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, beforeEval, asymmetricInstance)
+          ) - asymmetricInstance.ToSingleObjective(beforeEval);
         Assert.IsTrue(Math.Abs(moveDiff - (after - before)) < 1e-07, "Failed on asymmetric matrices: " + Environment.NewLine
           + "Quality changed from " + before + " to " + after + " (" + (after - before).ToString() + "), but move quality change was " + moveDiff + ".");
 
-        before = evaluator.Evaluate(prevAssignment, nonZeroDiagonalWeights, nonZeroDiagonalDistances, installationCosts, demands, capacities, transportationCosts, 0);
-        after = evaluator.Evaluate(assignment, nonZeroDiagonalWeights, nonZeroDiagonalDistances, installationCosts, demands, capacities, transportationCosts, 0);
-        moveDiff = GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, nonZeroDiagonalWeights, nonZeroDiagonalDistances, installationCosts, demands, capacities, transportationCosts, 0, evaluator);
+        beforeEval = nonZeroDiagonalInstance.Evaluate(prevAssignment);
+        before = nonZeroDiagonalInstance.ToSingleObjective(beforeEval);
+        after = Evaluate(nonZeroDiagonalInstance, assignment);
+        moveDiff = nonZeroDiagonalInstance.ToSingleObjective(
+          GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, beforeEval, nonZeroDiagonalInstance)
+          ) - nonZeroDiagonalInstance.ToSingleObjective(beforeEval);
         Assert.IsTrue(Math.Abs(moveDiff - (after - before)) < 1e-07, "Failed on non-zero diagonal matrices: " + Environment.NewLine
           + "Quality changed from " + before + " to " + after + " (" + (after - before).ToString() + "), but move quality change was " + moveDiff + ".");
       }
     }
+
+    private double Evaluate(GQAPInstance instance, IntegerVector assignment) {
+      return instance.ToSingleObjective(instance.Evaluate(assignment));
+    }
   }
 }
Index: /branches/GeneralizedQAP/UnitTests/Properties/AssemblyInfo.cs
===================================================================
--- /branches/GeneralizedQAP/UnitTests/Properties/AssemblyInfo.cs	(revision 15503)
+++ /branches/GeneralizedQAP/UnitTests/Properties/AssemblyInfo.cs	(revision 15504)
@@ -1,4 +1,3 @@
 ﻿using System.Reflection;
-using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
 
@@ -9,7 +8,7 @@
 [assembly: AssemblyDescription("")]
 [assembly: AssemblyConfiguration("")]
-[assembly: AssemblyCompany("Microsoft")]
+[assembly: AssemblyCompany("HEAL")]
 [assembly: AssemblyProduct("UnitTests")]
-[assembly: AssemblyCopyright("Copyright © Microsoft 2012")]
+[assembly: AssemblyCopyright("(c) 2002-2017 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
